// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: resourcemodule/resourcemodule.proto

package openfmb.resourcemodule;

/**
 * <pre>
 * Resource discrete control class
 * </pre>
 *
 * Protobuf type {@code resourcemodule.ResourceDiscreteControl}
 */
public final class ResourceDiscreteControl extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:resourcemodule.ResourceDiscreteControl)
    ResourceDiscreteControlOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ResourceDiscreteControl.newBuilder() to construct.
  private ResourceDiscreteControl(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ResourceDiscreteControl() {
    analogControlGGIO_ = java.util.Collections.emptyList();
    booleanControlGGIO_ = java.util.Collections.emptyList();
    integerControlGGIO_ = java.util.Collections.emptyList();
    stringControlGGIO_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ResourceDiscreteControl();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_ResourceDiscreteControl_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_ResourceDiscreteControl_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.resourcemodule.ResourceDiscreteControl.class, openfmb.resourcemodule.ResourceDiscreteControl.Builder.class);
  }

  public static final int IDENTIFIEDOBJECT_FIELD_NUMBER = 1;
  private openfmb.commonmodule.IdentifiedObject identifiedObject_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the identifiedObject field is set.
   */
  @java.lang.Override
  public boolean hasIdentifiedObject() {
    return identifiedObject_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   * @return The identifiedObject.
   */
  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObject getIdentifiedObject() {
    return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObjectOrBuilder getIdentifiedObjectOrBuilder() {
    return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
  }

  public static final int CHECK_FIELD_NUMBER = 2;
  private openfmb.commonmodule.CheckConditions check_;
  /**
   * <pre>
   * IEC61850 enhanced control parameters.
   * </pre>
   *
   * <code>.commonmodule.CheckConditions check = 2;</code>
   * @return Whether the check field is set.
   */
  @java.lang.Override
  public boolean hasCheck() {
    return check_ != null;
  }
  /**
   * <pre>
   * IEC61850 enhanced control parameters.
   * </pre>
   *
   * <code>.commonmodule.CheckConditions check = 2;</code>
   * @return The check.
   */
  @java.lang.Override
  public openfmb.commonmodule.CheckConditions getCheck() {
    return check_ == null ? openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
  }
  /**
   * <pre>
   * IEC61850 enhanced control parameters.
   * </pre>
   *
   * <code>.commonmodule.CheckConditions check = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.CheckConditionsOrBuilder getCheckOrBuilder() {
    return check_ == null ? openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
  }

  public static final int ANALOGCONTROLGGIO_FIELD_NUMBER = 3;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.resourcemodule.AnalogControlGGIO> analogControlGGIO_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.resourcemodule.AnalogControlGGIO> getAnalogControlGGIOList() {
    return analogControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.resourcemodule.AnalogControlGGIOOrBuilder> 
      getAnalogControlGGIOOrBuilderList() {
    return analogControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public int getAnalogControlGGIOCount() {
    return analogControlGGIO_.size();
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.AnalogControlGGIO getAnalogControlGGIO(int index) {
    return analogControlGGIO_.get(index);
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.AnalogControlGGIOOrBuilder getAnalogControlGGIOOrBuilder(
      int index) {
    return analogControlGGIO_.get(index);
  }

  public static final int BOOLEANCONTROLGGIO_FIELD_NUMBER = 4;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.resourcemodule.BooleanControlGGIO> booleanControlGGIO_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.resourcemodule.BooleanControlGGIO> getBooleanControlGGIOList() {
    return booleanControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.resourcemodule.BooleanControlGGIOOrBuilder> 
      getBooleanControlGGIOOrBuilderList() {
    return booleanControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public int getBooleanControlGGIOCount() {
    return booleanControlGGIO_.size();
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.BooleanControlGGIO getBooleanControlGGIO(int index) {
    return booleanControlGGIO_.get(index);
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.BooleanControlGGIOOrBuilder getBooleanControlGGIOOrBuilder(
      int index) {
    return booleanControlGGIO_.get(index);
  }

  public static final int INTEGERCONTROLGGIO_FIELD_NUMBER = 5;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.resourcemodule.IntegerControlGGIO> integerControlGGIO_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.resourcemodule.IntegerControlGGIO> getIntegerControlGGIOList() {
    return integerControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.resourcemodule.IntegerControlGGIOOrBuilder> 
      getIntegerControlGGIOOrBuilderList() {
    return integerControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public int getIntegerControlGGIOCount() {
    return integerControlGGIO_.size();
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.IntegerControlGGIO getIntegerControlGGIO(int index) {
    return integerControlGGIO_.get(index);
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.IntegerControlGGIOOrBuilder getIntegerControlGGIOOrBuilder(
      int index) {
    return integerControlGGIO_.get(index);
  }

  public static final int STRINGCONTROLGGIO_FIELD_NUMBER = 6;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.resourcemodule.StringControlGGIO> stringControlGGIO_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.resourcemodule.StringControlGGIO> getStringControlGGIOList() {
    return stringControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.resourcemodule.StringControlGGIOOrBuilder> 
      getStringControlGGIOOrBuilderList() {
    return stringControlGGIO_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public int getStringControlGGIOCount() {
    return stringControlGGIO_.size();
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.StringControlGGIO getStringControlGGIO(int index) {
    return stringControlGGIO_.get(index);
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
   */
  @java.lang.Override
  public openfmb.resourcemodule.StringControlGGIOOrBuilder getStringControlGGIOOrBuilder(
      int index) {
    return stringControlGGIO_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (identifiedObject_ != null) {
      output.writeMessage(1, getIdentifiedObject());
    }
    if (check_ != null) {
      output.writeMessage(2, getCheck());
    }
    for (int i = 0; i < analogControlGGIO_.size(); i++) {
      output.writeMessage(3, analogControlGGIO_.get(i));
    }
    for (int i = 0; i < booleanControlGGIO_.size(); i++) {
      output.writeMessage(4, booleanControlGGIO_.get(i));
    }
    for (int i = 0; i < integerControlGGIO_.size(); i++) {
      output.writeMessage(5, integerControlGGIO_.get(i));
    }
    for (int i = 0; i < stringControlGGIO_.size(); i++) {
      output.writeMessage(6, stringControlGGIO_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (identifiedObject_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getIdentifiedObject());
    }
    if (check_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getCheck());
    }
    for (int i = 0; i < analogControlGGIO_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, analogControlGGIO_.get(i));
    }
    for (int i = 0; i < booleanControlGGIO_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, booleanControlGGIO_.get(i));
    }
    for (int i = 0; i < integerControlGGIO_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, integerControlGGIO_.get(i));
    }
    for (int i = 0; i < stringControlGGIO_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, stringControlGGIO_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.resourcemodule.ResourceDiscreteControl)) {
      return super.equals(obj);
    }
    openfmb.resourcemodule.ResourceDiscreteControl other = (openfmb.resourcemodule.ResourceDiscreteControl) obj;

    if (hasIdentifiedObject() != other.hasIdentifiedObject()) return false;
    if (hasIdentifiedObject()) {
      if (!getIdentifiedObject()
          .equals(other.getIdentifiedObject())) return false;
    }
    if (hasCheck() != other.hasCheck()) return false;
    if (hasCheck()) {
      if (!getCheck()
          .equals(other.getCheck())) return false;
    }
    if (!getAnalogControlGGIOList()
        .equals(other.getAnalogControlGGIOList())) return false;
    if (!getBooleanControlGGIOList()
        .equals(other.getBooleanControlGGIOList())) return false;
    if (!getIntegerControlGGIOList()
        .equals(other.getIntegerControlGGIOList())) return false;
    if (!getStringControlGGIOList()
        .equals(other.getStringControlGGIOList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasIdentifiedObject()) {
      hash = (37 * hash) + IDENTIFIEDOBJECT_FIELD_NUMBER;
      hash = (53 * hash) + getIdentifiedObject().hashCode();
    }
    if (hasCheck()) {
      hash = (37 * hash) + CHECK_FIELD_NUMBER;
      hash = (53 * hash) + getCheck().hashCode();
    }
    if (getAnalogControlGGIOCount() > 0) {
      hash = (37 * hash) + ANALOGCONTROLGGIO_FIELD_NUMBER;
      hash = (53 * hash) + getAnalogControlGGIOList().hashCode();
    }
    if (getBooleanControlGGIOCount() > 0) {
      hash = (37 * hash) + BOOLEANCONTROLGGIO_FIELD_NUMBER;
      hash = (53 * hash) + getBooleanControlGGIOList().hashCode();
    }
    if (getIntegerControlGGIOCount() > 0) {
      hash = (37 * hash) + INTEGERCONTROLGGIO_FIELD_NUMBER;
      hash = (53 * hash) + getIntegerControlGGIOList().hashCode();
    }
    if (getStringControlGGIOCount() > 0) {
      hash = (37 * hash) + STRINGCONTROLGGIO_FIELD_NUMBER;
      hash = (53 * hash) + getStringControlGGIOList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.resourcemodule.ResourceDiscreteControl parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.resourcemodule.ResourceDiscreteControl prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Resource discrete control class
   * </pre>
   *
   * Protobuf type {@code resourcemodule.ResourceDiscreteControl}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:resourcemodule.ResourceDiscreteControl)
      openfmb.resourcemodule.ResourceDiscreteControlOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_ResourceDiscreteControl_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_ResourceDiscreteControl_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.resourcemodule.ResourceDiscreteControl.class, openfmb.resourcemodule.ResourceDiscreteControl.Builder.class);
    }

    // Construct using openfmb.resourcemodule.ResourceDiscreteControl.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      identifiedObject_ = null;
      if (identifiedObjectBuilder_ != null) {
        identifiedObjectBuilder_.dispose();
        identifiedObjectBuilder_ = null;
      }
      check_ = null;
      if (checkBuilder_ != null) {
        checkBuilder_.dispose();
        checkBuilder_ = null;
      }
      if (analogControlGGIOBuilder_ == null) {
        analogControlGGIO_ = java.util.Collections.emptyList();
      } else {
        analogControlGGIO_ = null;
        analogControlGGIOBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000004);
      if (booleanControlGGIOBuilder_ == null) {
        booleanControlGGIO_ = java.util.Collections.emptyList();
      } else {
        booleanControlGGIO_ = null;
        booleanControlGGIOBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000008);
      if (integerControlGGIOBuilder_ == null) {
        integerControlGGIO_ = java.util.Collections.emptyList();
      } else {
        integerControlGGIO_ = null;
        integerControlGGIOBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000010);
      if (stringControlGGIOBuilder_ == null) {
        stringControlGGIO_ = java.util.Collections.emptyList();
      } else {
        stringControlGGIO_ = null;
        stringControlGGIOBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000020);
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.resourcemodule.Resourcemodule.internal_static_resourcemodule_ResourceDiscreteControl_descriptor;
    }

    @java.lang.Override
    public openfmb.resourcemodule.ResourceDiscreteControl getDefaultInstanceForType() {
      return openfmb.resourcemodule.ResourceDiscreteControl.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.resourcemodule.ResourceDiscreteControl build() {
      openfmb.resourcemodule.ResourceDiscreteControl result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.resourcemodule.ResourceDiscreteControl buildPartial() {
      openfmb.resourcemodule.ResourceDiscreteControl result = new openfmb.resourcemodule.ResourceDiscreteControl(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(openfmb.resourcemodule.ResourceDiscreteControl result) {
      if (analogControlGGIOBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0)) {
          analogControlGGIO_ = java.util.Collections.unmodifiableList(analogControlGGIO_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.analogControlGGIO_ = analogControlGGIO_;
      } else {
        result.analogControlGGIO_ = analogControlGGIOBuilder_.build();
      }
      if (booleanControlGGIOBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0)) {
          booleanControlGGIO_ = java.util.Collections.unmodifiableList(booleanControlGGIO_);
          bitField0_ = (bitField0_ & ~0x00000008);
        }
        result.booleanControlGGIO_ = booleanControlGGIO_;
      } else {
        result.booleanControlGGIO_ = booleanControlGGIOBuilder_.build();
      }
      if (integerControlGGIOBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0)) {
          integerControlGGIO_ = java.util.Collections.unmodifiableList(integerControlGGIO_);
          bitField0_ = (bitField0_ & ~0x00000010);
        }
        result.integerControlGGIO_ = integerControlGGIO_;
      } else {
        result.integerControlGGIO_ = integerControlGGIOBuilder_.build();
      }
      if (stringControlGGIOBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0)) {
          stringControlGGIO_ = java.util.Collections.unmodifiableList(stringControlGGIO_);
          bitField0_ = (bitField0_ & ~0x00000020);
        }
        result.stringControlGGIO_ = stringControlGGIO_;
      } else {
        result.stringControlGGIO_ = stringControlGGIOBuilder_.build();
      }
    }

    private void buildPartial0(openfmb.resourcemodule.ResourceDiscreteControl result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.identifiedObject_ = identifiedObjectBuilder_ == null
            ? identifiedObject_
            : identifiedObjectBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.check_ = checkBuilder_ == null
            ? check_
            : checkBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.resourcemodule.ResourceDiscreteControl) {
        return mergeFrom((openfmb.resourcemodule.ResourceDiscreteControl)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.resourcemodule.ResourceDiscreteControl other) {
      if (other == openfmb.resourcemodule.ResourceDiscreteControl.getDefaultInstance()) return this;
      if (other.hasIdentifiedObject()) {
        mergeIdentifiedObject(other.getIdentifiedObject());
      }
      if (other.hasCheck()) {
        mergeCheck(other.getCheck());
      }
      if (analogControlGGIOBuilder_ == null) {
        if (!other.analogControlGGIO_.isEmpty()) {
          if (analogControlGGIO_.isEmpty()) {
            analogControlGGIO_ = other.analogControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureAnalogControlGGIOIsMutable();
            analogControlGGIO_.addAll(other.analogControlGGIO_);
          }
          onChanged();
        }
      } else {
        if (!other.analogControlGGIO_.isEmpty()) {
          if (analogControlGGIOBuilder_.isEmpty()) {
            analogControlGGIOBuilder_.dispose();
            analogControlGGIOBuilder_ = null;
            analogControlGGIO_ = other.analogControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000004);
            analogControlGGIOBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getAnalogControlGGIOFieldBuilder() : null;
          } else {
            analogControlGGIOBuilder_.addAllMessages(other.analogControlGGIO_);
          }
        }
      }
      if (booleanControlGGIOBuilder_ == null) {
        if (!other.booleanControlGGIO_.isEmpty()) {
          if (booleanControlGGIO_.isEmpty()) {
            booleanControlGGIO_ = other.booleanControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000008);
          } else {
            ensureBooleanControlGGIOIsMutable();
            booleanControlGGIO_.addAll(other.booleanControlGGIO_);
          }
          onChanged();
        }
      } else {
        if (!other.booleanControlGGIO_.isEmpty()) {
          if (booleanControlGGIOBuilder_.isEmpty()) {
            booleanControlGGIOBuilder_.dispose();
            booleanControlGGIOBuilder_ = null;
            booleanControlGGIO_ = other.booleanControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000008);
            booleanControlGGIOBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getBooleanControlGGIOFieldBuilder() : null;
          } else {
            booleanControlGGIOBuilder_.addAllMessages(other.booleanControlGGIO_);
          }
        }
      }
      if (integerControlGGIOBuilder_ == null) {
        if (!other.integerControlGGIO_.isEmpty()) {
          if (integerControlGGIO_.isEmpty()) {
            integerControlGGIO_ = other.integerControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000010);
          } else {
            ensureIntegerControlGGIOIsMutable();
            integerControlGGIO_.addAll(other.integerControlGGIO_);
          }
          onChanged();
        }
      } else {
        if (!other.integerControlGGIO_.isEmpty()) {
          if (integerControlGGIOBuilder_.isEmpty()) {
            integerControlGGIOBuilder_.dispose();
            integerControlGGIOBuilder_ = null;
            integerControlGGIO_ = other.integerControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000010);
            integerControlGGIOBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getIntegerControlGGIOFieldBuilder() : null;
          } else {
            integerControlGGIOBuilder_.addAllMessages(other.integerControlGGIO_);
          }
        }
      }
      if (stringControlGGIOBuilder_ == null) {
        if (!other.stringControlGGIO_.isEmpty()) {
          if (stringControlGGIO_.isEmpty()) {
            stringControlGGIO_ = other.stringControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000020);
          } else {
            ensureStringControlGGIOIsMutable();
            stringControlGGIO_.addAll(other.stringControlGGIO_);
          }
          onChanged();
        }
      } else {
        if (!other.stringControlGGIO_.isEmpty()) {
          if (stringControlGGIOBuilder_.isEmpty()) {
            stringControlGGIOBuilder_.dispose();
            stringControlGGIOBuilder_ = null;
            stringControlGGIO_ = other.stringControlGGIO_;
            bitField0_ = (bitField0_ & ~0x00000020);
            stringControlGGIOBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getStringControlGGIOFieldBuilder() : null;
          } else {
            stringControlGGIOBuilder_.addAllMessages(other.stringControlGGIO_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getIdentifiedObjectFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getCheckFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              openfmb.resourcemodule.AnalogControlGGIO m =
                  input.readMessage(
                      openfmb.resourcemodule.AnalogControlGGIO.parser(),
                      extensionRegistry);
              if (analogControlGGIOBuilder_ == null) {
                ensureAnalogControlGGIOIsMutable();
                analogControlGGIO_.add(m);
              } else {
                analogControlGGIOBuilder_.addMessage(m);
              }
              break;
            } // case 26
            case 34: {
              openfmb.resourcemodule.BooleanControlGGIO m =
                  input.readMessage(
                      openfmb.resourcemodule.BooleanControlGGIO.parser(),
                      extensionRegistry);
              if (booleanControlGGIOBuilder_ == null) {
                ensureBooleanControlGGIOIsMutable();
                booleanControlGGIO_.add(m);
              } else {
                booleanControlGGIOBuilder_.addMessage(m);
              }
              break;
            } // case 34
            case 42: {
              openfmb.resourcemodule.IntegerControlGGIO m =
                  input.readMessage(
                      openfmb.resourcemodule.IntegerControlGGIO.parser(),
                      extensionRegistry);
              if (integerControlGGIOBuilder_ == null) {
                ensureIntegerControlGGIOIsMutable();
                integerControlGGIO_.add(m);
              } else {
                integerControlGGIOBuilder_.addMessage(m);
              }
              break;
            } // case 42
            case 50: {
              openfmb.resourcemodule.StringControlGGIO m =
                  input.readMessage(
                      openfmb.resourcemodule.StringControlGGIO.parser(),
                      extensionRegistry);
              if (stringControlGGIOBuilder_ == null) {
                ensureStringControlGGIOIsMutable();
                stringControlGGIO_.add(m);
              } else {
                stringControlGGIOBuilder_.addMessage(m);
              }
              break;
            } // case 50
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.IdentifiedObject identifiedObject_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder> identifiedObjectBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the identifiedObject field is set.
     */
    public boolean hasIdentifiedObject() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     * @return The identifiedObject.
     */
    public openfmb.commonmodule.IdentifiedObject getIdentifiedObject() {
      if (identifiedObjectBuilder_ == null) {
        return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
      } else {
        return identifiedObjectBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setIdentifiedObject(openfmb.commonmodule.IdentifiedObject value) {
      if (identifiedObjectBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        identifiedObject_ = value;
      } else {
        identifiedObjectBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setIdentifiedObject(
        openfmb.commonmodule.IdentifiedObject.Builder builderForValue) {
      if (identifiedObjectBuilder_ == null) {
        identifiedObject_ = builderForValue.build();
      } else {
        identifiedObjectBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeIdentifiedObject(openfmb.commonmodule.IdentifiedObject value) {
      if (identifiedObjectBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          identifiedObject_ != null &&
          identifiedObject_ != openfmb.commonmodule.IdentifiedObject.getDefaultInstance()) {
          getIdentifiedObjectBuilder().mergeFrom(value);
        } else {
          identifiedObject_ = value;
        }
      } else {
        identifiedObjectBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearIdentifiedObject() {
      bitField0_ = (bitField0_ & ~0x00000001);
      identifiedObject_ = null;
      if (identifiedObjectBuilder_ != null) {
        identifiedObjectBuilder_.dispose();
        identifiedObjectBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.IdentifiedObject.Builder getIdentifiedObjectBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getIdentifiedObjectFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.IdentifiedObjectOrBuilder getIdentifiedObjectOrBuilder() {
      if (identifiedObjectBuilder_ != null) {
        return identifiedObjectBuilder_.getMessageOrBuilder();
      } else {
        return identifiedObject_ == null ?
            openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder> 
        getIdentifiedObjectFieldBuilder() {
      if (identifiedObjectBuilder_ == null) {
        identifiedObjectBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder>(
                getIdentifiedObject(),
                getParentForChildren(),
                isClean());
        identifiedObject_ = null;
      }
      return identifiedObjectBuilder_;
    }

    private openfmb.commonmodule.CheckConditions check_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CheckConditions, openfmb.commonmodule.CheckConditions.Builder, openfmb.commonmodule.CheckConditionsOrBuilder> checkBuilder_;
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     * @return Whether the check field is set.
     */
    public boolean hasCheck() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     * @return The check.
     */
    public openfmb.commonmodule.CheckConditions getCheck() {
      if (checkBuilder_ == null) {
        return check_ == null ? openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
      } else {
        return checkBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder setCheck(openfmb.commonmodule.CheckConditions value) {
      if (checkBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        check_ = value;
      } else {
        checkBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder setCheck(
        openfmb.commonmodule.CheckConditions.Builder builderForValue) {
      if (checkBuilder_ == null) {
        check_ = builderForValue.build();
      } else {
        checkBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder mergeCheck(openfmb.commonmodule.CheckConditions value) {
      if (checkBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          check_ != null &&
          check_ != openfmb.commonmodule.CheckConditions.getDefaultInstance()) {
          getCheckBuilder().mergeFrom(value);
        } else {
          check_ = value;
        }
      } else {
        checkBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public Builder clearCheck() {
      bitField0_ = (bitField0_ & ~0x00000002);
      check_ = null;
      if (checkBuilder_ != null) {
        checkBuilder_.dispose();
        checkBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public openfmb.commonmodule.CheckConditions.Builder getCheckBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getCheckFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    public openfmb.commonmodule.CheckConditionsOrBuilder getCheckOrBuilder() {
      if (checkBuilder_ != null) {
        return checkBuilder_.getMessageOrBuilder();
      } else {
        return check_ == null ?
            openfmb.commonmodule.CheckConditions.getDefaultInstance() : check_;
      }
    }
    /**
     * <pre>
     * IEC61850 enhanced control parameters.
     * </pre>
     *
     * <code>.commonmodule.CheckConditions check = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.CheckConditions, openfmb.commonmodule.CheckConditions.Builder, openfmb.commonmodule.CheckConditionsOrBuilder> 
        getCheckFieldBuilder() {
      if (checkBuilder_ == null) {
        checkBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.CheckConditions, openfmb.commonmodule.CheckConditions.Builder, openfmb.commonmodule.CheckConditionsOrBuilder>(
                getCheck(),
                getParentForChildren(),
                isClean());
        check_ = null;
      }
      return checkBuilder_;
    }

    private java.util.List<openfmb.resourcemodule.AnalogControlGGIO> analogControlGGIO_ =
      java.util.Collections.emptyList();
    private void ensureAnalogControlGGIOIsMutable() {
      if (!((bitField0_ & 0x00000004) != 0)) {
        analogControlGGIO_ = new java.util.ArrayList<openfmb.resourcemodule.AnalogControlGGIO>(analogControlGGIO_);
        bitField0_ |= 0x00000004;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.AnalogControlGGIO, openfmb.resourcemodule.AnalogControlGGIO.Builder, openfmb.resourcemodule.AnalogControlGGIOOrBuilder> analogControlGGIOBuilder_;

    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.AnalogControlGGIO> getAnalogControlGGIOList() {
      if (analogControlGGIOBuilder_ == null) {
        return java.util.Collections.unmodifiableList(analogControlGGIO_);
      } else {
        return analogControlGGIOBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public int getAnalogControlGGIOCount() {
      if (analogControlGGIOBuilder_ == null) {
        return analogControlGGIO_.size();
      } else {
        return analogControlGGIOBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.AnalogControlGGIO getAnalogControlGGIO(int index) {
      if (analogControlGGIOBuilder_ == null) {
        return analogControlGGIO_.get(index);
      } else {
        return analogControlGGIOBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setAnalogControlGGIO(
        int index, openfmb.resourcemodule.AnalogControlGGIO value) {
      if (analogControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.set(index, value);
        onChanged();
      } else {
        analogControlGGIOBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setAnalogControlGGIO(
        int index, openfmb.resourcemodule.AnalogControlGGIO.Builder builderForValue) {
      if (analogControlGGIOBuilder_ == null) {
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.set(index, builderForValue.build());
        onChanged();
      } else {
        analogControlGGIOBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAnalogControlGGIO(openfmb.resourcemodule.AnalogControlGGIO value) {
      if (analogControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.add(value);
        onChanged();
      } else {
        analogControlGGIOBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAnalogControlGGIO(
        int index, openfmb.resourcemodule.AnalogControlGGIO value) {
      if (analogControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.add(index, value);
        onChanged();
      } else {
        analogControlGGIOBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAnalogControlGGIO(
        openfmb.resourcemodule.AnalogControlGGIO.Builder builderForValue) {
      if (analogControlGGIOBuilder_ == null) {
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.add(builderForValue.build());
        onChanged();
      } else {
        analogControlGGIOBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAnalogControlGGIO(
        int index, openfmb.resourcemodule.AnalogControlGGIO.Builder builderForValue) {
      if (analogControlGGIOBuilder_ == null) {
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.add(index, builderForValue.build());
        onChanged();
      } else {
        analogControlGGIOBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAllAnalogControlGGIO(
        java.lang.Iterable<? extends openfmb.resourcemodule.AnalogControlGGIO> values) {
      if (analogControlGGIOBuilder_ == null) {
        ensureAnalogControlGGIOIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, analogControlGGIO_);
        onChanged();
      } else {
        analogControlGGIOBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder clearAnalogControlGGIO() {
      if (analogControlGGIOBuilder_ == null) {
        analogControlGGIO_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
      } else {
        analogControlGGIOBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder removeAnalogControlGGIO(int index) {
      if (analogControlGGIOBuilder_ == null) {
        ensureAnalogControlGGIOIsMutable();
        analogControlGGIO_.remove(index);
        onChanged();
      } else {
        analogControlGGIOBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.AnalogControlGGIO.Builder getAnalogControlGGIOBuilder(
        int index) {
      return getAnalogControlGGIOFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.AnalogControlGGIOOrBuilder getAnalogControlGGIOOrBuilder(
        int index) {
      if (analogControlGGIOBuilder_ == null) {
        return analogControlGGIO_.get(index);  } else {
        return analogControlGGIOBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<? extends openfmb.resourcemodule.AnalogControlGGIOOrBuilder> 
         getAnalogControlGGIOOrBuilderList() {
      if (analogControlGGIOBuilder_ != null) {
        return analogControlGGIOBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(analogControlGGIO_);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.AnalogControlGGIO.Builder addAnalogControlGGIOBuilder() {
      return getAnalogControlGGIOFieldBuilder().addBuilder(
          openfmb.resourcemodule.AnalogControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.AnalogControlGGIO.Builder addAnalogControlGGIOBuilder(
        int index) {
      return getAnalogControlGGIOFieldBuilder().addBuilder(
          index, openfmb.resourcemodule.AnalogControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.AnalogControlGGIO analogControlGGIO = 3 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.AnalogControlGGIO.Builder> 
         getAnalogControlGGIOBuilderList() {
      return getAnalogControlGGIOFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.AnalogControlGGIO, openfmb.resourcemodule.AnalogControlGGIO.Builder, openfmb.resourcemodule.AnalogControlGGIOOrBuilder> 
        getAnalogControlGGIOFieldBuilder() {
      if (analogControlGGIOBuilder_ == null) {
        analogControlGGIOBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.resourcemodule.AnalogControlGGIO, openfmb.resourcemodule.AnalogControlGGIO.Builder, openfmb.resourcemodule.AnalogControlGGIOOrBuilder>(
                analogControlGGIO_,
                ((bitField0_ & 0x00000004) != 0),
                getParentForChildren(),
                isClean());
        analogControlGGIO_ = null;
      }
      return analogControlGGIOBuilder_;
    }

    private java.util.List<openfmb.resourcemodule.BooleanControlGGIO> booleanControlGGIO_ =
      java.util.Collections.emptyList();
    private void ensureBooleanControlGGIOIsMutable() {
      if (!((bitField0_ & 0x00000008) != 0)) {
        booleanControlGGIO_ = new java.util.ArrayList<openfmb.resourcemodule.BooleanControlGGIO>(booleanControlGGIO_);
        bitField0_ |= 0x00000008;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.BooleanControlGGIO, openfmb.resourcemodule.BooleanControlGGIO.Builder, openfmb.resourcemodule.BooleanControlGGIOOrBuilder> booleanControlGGIOBuilder_;

    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.BooleanControlGGIO> getBooleanControlGGIOList() {
      if (booleanControlGGIOBuilder_ == null) {
        return java.util.Collections.unmodifiableList(booleanControlGGIO_);
      } else {
        return booleanControlGGIOBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public int getBooleanControlGGIOCount() {
      if (booleanControlGGIOBuilder_ == null) {
        return booleanControlGGIO_.size();
      } else {
        return booleanControlGGIOBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.BooleanControlGGIO getBooleanControlGGIO(int index) {
      if (booleanControlGGIOBuilder_ == null) {
        return booleanControlGGIO_.get(index);
      } else {
        return booleanControlGGIOBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setBooleanControlGGIO(
        int index, openfmb.resourcemodule.BooleanControlGGIO value) {
      if (booleanControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.set(index, value);
        onChanged();
      } else {
        booleanControlGGIOBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setBooleanControlGGIO(
        int index, openfmb.resourcemodule.BooleanControlGGIO.Builder builderForValue) {
      if (booleanControlGGIOBuilder_ == null) {
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.set(index, builderForValue.build());
        onChanged();
      } else {
        booleanControlGGIOBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addBooleanControlGGIO(openfmb.resourcemodule.BooleanControlGGIO value) {
      if (booleanControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.add(value);
        onChanged();
      } else {
        booleanControlGGIOBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addBooleanControlGGIO(
        int index, openfmb.resourcemodule.BooleanControlGGIO value) {
      if (booleanControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.add(index, value);
        onChanged();
      } else {
        booleanControlGGIOBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addBooleanControlGGIO(
        openfmb.resourcemodule.BooleanControlGGIO.Builder builderForValue) {
      if (booleanControlGGIOBuilder_ == null) {
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.add(builderForValue.build());
        onChanged();
      } else {
        booleanControlGGIOBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addBooleanControlGGIO(
        int index, openfmb.resourcemodule.BooleanControlGGIO.Builder builderForValue) {
      if (booleanControlGGIOBuilder_ == null) {
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.add(index, builderForValue.build());
        onChanged();
      } else {
        booleanControlGGIOBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAllBooleanControlGGIO(
        java.lang.Iterable<? extends openfmb.resourcemodule.BooleanControlGGIO> values) {
      if (booleanControlGGIOBuilder_ == null) {
        ensureBooleanControlGGIOIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, booleanControlGGIO_);
        onChanged();
      } else {
        booleanControlGGIOBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder clearBooleanControlGGIO() {
      if (booleanControlGGIOBuilder_ == null) {
        booleanControlGGIO_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
      } else {
        booleanControlGGIOBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder removeBooleanControlGGIO(int index) {
      if (booleanControlGGIOBuilder_ == null) {
        ensureBooleanControlGGIOIsMutable();
        booleanControlGGIO_.remove(index);
        onChanged();
      } else {
        booleanControlGGIOBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.BooleanControlGGIO.Builder getBooleanControlGGIOBuilder(
        int index) {
      return getBooleanControlGGIOFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.BooleanControlGGIOOrBuilder getBooleanControlGGIOOrBuilder(
        int index) {
      if (booleanControlGGIOBuilder_ == null) {
        return booleanControlGGIO_.get(index);  } else {
        return booleanControlGGIOBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<? extends openfmb.resourcemodule.BooleanControlGGIOOrBuilder> 
         getBooleanControlGGIOOrBuilderList() {
      if (booleanControlGGIOBuilder_ != null) {
        return booleanControlGGIOBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(booleanControlGGIO_);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.BooleanControlGGIO.Builder addBooleanControlGGIOBuilder() {
      return getBooleanControlGGIOFieldBuilder().addBuilder(
          openfmb.resourcemodule.BooleanControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.BooleanControlGGIO.Builder addBooleanControlGGIOBuilder(
        int index) {
      return getBooleanControlGGIOFieldBuilder().addBuilder(
          index, openfmb.resourcemodule.BooleanControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.BooleanControlGGIO booleanControlGGIO = 4 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.BooleanControlGGIO.Builder> 
         getBooleanControlGGIOBuilderList() {
      return getBooleanControlGGIOFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.BooleanControlGGIO, openfmb.resourcemodule.BooleanControlGGIO.Builder, openfmb.resourcemodule.BooleanControlGGIOOrBuilder> 
        getBooleanControlGGIOFieldBuilder() {
      if (booleanControlGGIOBuilder_ == null) {
        booleanControlGGIOBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.resourcemodule.BooleanControlGGIO, openfmb.resourcemodule.BooleanControlGGIO.Builder, openfmb.resourcemodule.BooleanControlGGIOOrBuilder>(
                booleanControlGGIO_,
                ((bitField0_ & 0x00000008) != 0),
                getParentForChildren(),
                isClean());
        booleanControlGGIO_ = null;
      }
      return booleanControlGGIOBuilder_;
    }

    private java.util.List<openfmb.resourcemodule.IntegerControlGGIO> integerControlGGIO_ =
      java.util.Collections.emptyList();
    private void ensureIntegerControlGGIOIsMutable() {
      if (!((bitField0_ & 0x00000010) != 0)) {
        integerControlGGIO_ = new java.util.ArrayList<openfmb.resourcemodule.IntegerControlGGIO>(integerControlGGIO_);
        bitField0_ |= 0x00000010;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.IntegerControlGGIO, openfmb.resourcemodule.IntegerControlGGIO.Builder, openfmb.resourcemodule.IntegerControlGGIOOrBuilder> integerControlGGIOBuilder_;

    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.IntegerControlGGIO> getIntegerControlGGIOList() {
      if (integerControlGGIOBuilder_ == null) {
        return java.util.Collections.unmodifiableList(integerControlGGIO_);
      } else {
        return integerControlGGIOBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public int getIntegerControlGGIOCount() {
      if (integerControlGGIOBuilder_ == null) {
        return integerControlGGIO_.size();
      } else {
        return integerControlGGIOBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.IntegerControlGGIO getIntegerControlGGIO(int index) {
      if (integerControlGGIOBuilder_ == null) {
        return integerControlGGIO_.get(index);
      } else {
        return integerControlGGIOBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setIntegerControlGGIO(
        int index, openfmb.resourcemodule.IntegerControlGGIO value) {
      if (integerControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.set(index, value);
        onChanged();
      } else {
        integerControlGGIOBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setIntegerControlGGIO(
        int index, openfmb.resourcemodule.IntegerControlGGIO.Builder builderForValue) {
      if (integerControlGGIOBuilder_ == null) {
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.set(index, builderForValue.build());
        onChanged();
      } else {
        integerControlGGIOBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addIntegerControlGGIO(openfmb.resourcemodule.IntegerControlGGIO value) {
      if (integerControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.add(value);
        onChanged();
      } else {
        integerControlGGIOBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addIntegerControlGGIO(
        int index, openfmb.resourcemodule.IntegerControlGGIO value) {
      if (integerControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.add(index, value);
        onChanged();
      } else {
        integerControlGGIOBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addIntegerControlGGIO(
        openfmb.resourcemodule.IntegerControlGGIO.Builder builderForValue) {
      if (integerControlGGIOBuilder_ == null) {
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.add(builderForValue.build());
        onChanged();
      } else {
        integerControlGGIOBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addIntegerControlGGIO(
        int index, openfmb.resourcemodule.IntegerControlGGIO.Builder builderForValue) {
      if (integerControlGGIOBuilder_ == null) {
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.add(index, builderForValue.build());
        onChanged();
      } else {
        integerControlGGIOBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAllIntegerControlGGIO(
        java.lang.Iterable<? extends openfmb.resourcemodule.IntegerControlGGIO> values) {
      if (integerControlGGIOBuilder_ == null) {
        ensureIntegerControlGGIOIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, integerControlGGIO_);
        onChanged();
      } else {
        integerControlGGIOBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder clearIntegerControlGGIO() {
      if (integerControlGGIOBuilder_ == null) {
        integerControlGGIO_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000010);
        onChanged();
      } else {
        integerControlGGIOBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder removeIntegerControlGGIO(int index) {
      if (integerControlGGIOBuilder_ == null) {
        ensureIntegerControlGGIOIsMutable();
        integerControlGGIO_.remove(index);
        onChanged();
      } else {
        integerControlGGIOBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.IntegerControlGGIO.Builder getIntegerControlGGIOBuilder(
        int index) {
      return getIntegerControlGGIOFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.IntegerControlGGIOOrBuilder getIntegerControlGGIOOrBuilder(
        int index) {
      if (integerControlGGIOBuilder_ == null) {
        return integerControlGGIO_.get(index);  } else {
        return integerControlGGIOBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<? extends openfmb.resourcemodule.IntegerControlGGIOOrBuilder> 
         getIntegerControlGGIOOrBuilderList() {
      if (integerControlGGIOBuilder_ != null) {
        return integerControlGGIOBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(integerControlGGIO_);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.IntegerControlGGIO.Builder addIntegerControlGGIOBuilder() {
      return getIntegerControlGGIOFieldBuilder().addBuilder(
          openfmb.resourcemodule.IntegerControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.IntegerControlGGIO.Builder addIntegerControlGGIOBuilder(
        int index) {
      return getIntegerControlGGIOFieldBuilder().addBuilder(
          index, openfmb.resourcemodule.IntegerControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.IntegerControlGGIO integerControlGGIO = 5 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.IntegerControlGGIO.Builder> 
         getIntegerControlGGIOBuilderList() {
      return getIntegerControlGGIOFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.IntegerControlGGIO, openfmb.resourcemodule.IntegerControlGGIO.Builder, openfmb.resourcemodule.IntegerControlGGIOOrBuilder> 
        getIntegerControlGGIOFieldBuilder() {
      if (integerControlGGIOBuilder_ == null) {
        integerControlGGIOBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.resourcemodule.IntegerControlGGIO, openfmb.resourcemodule.IntegerControlGGIO.Builder, openfmb.resourcemodule.IntegerControlGGIOOrBuilder>(
                integerControlGGIO_,
                ((bitField0_ & 0x00000010) != 0),
                getParentForChildren(),
                isClean());
        integerControlGGIO_ = null;
      }
      return integerControlGGIOBuilder_;
    }

    private java.util.List<openfmb.resourcemodule.StringControlGGIO> stringControlGGIO_ =
      java.util.Collections.emptyList();
    private void ensureStringControlGGIOIsMutable() {
      if (!((bitField0_ & 0x00000020) != 0)) {
        stringControlGGIO_ = new java.util.ArrayList<openfmb.resourcemodule.StringControlGGIO>(stringControlGGIO_);
        bitField0_ |= 0x00000020;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.StringControlGGIO, openfmb.resourcemodule.StringControlGGIO.Builder, openfmb.resourcemodule.StringControlGGIOOrBuilder> stringControlGGIOBuilder_;

    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.StringControlGGIO> getStringControlGGIOList() {
      if (stringControlGGIOBuilder_ == null) {
        return java.util.Collections.unmodifiableList(stringControlGGIO_);
      } else {
        return stringControlGGIOBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public int getStringControlGGIOCount() {
      if (stringControlGGIOBuilder_ == null) {
        return stringControlGGIO_.size();
      } else {
        return stringControlGGIOBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.StringControlGGIO getStringControlGGIO(int index) {
      if (stringControlGGIOBuilder_ == null) {
        return stringControlGGIO_.get(index);
      } else {
        return stringControlGGIOBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setStringControlGGIO(
        int index, openfmb.resourcemodule.StringControlGGIO value) {
      if (stringControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.set(index, value);
        onChanged();
      } else {
        stringControlGGIOBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder setStringControlGGIO(
        int index, openfmb.resourcemodule.StringControlGGIO.Builder builderForValue) {
      if (stringControlGGIOBuilder_ == null) {
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.set(index, builderForValue.build());
        onChanged();
      } else {
        stringControlGGIOBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addStringControlGGIO(openfmb.resourcemodule.StringControlGGIO value) {
      if (stringControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.add(value);
        onChanged();
      } else {
        stringControlGGIOBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addStringControlGGIO(
        int index, openfmb.resourcemodule.StringControlGGIO value) {
      if (stringControlGGIOBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.add(index, value);
        onChanged();
      } else {
        stringControlGGIOBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addStringControlGGIO(
        openfmb.resourcemodule.StringControlGGIO.Builder builderForValue) {
      if (stringControlGGIOBuilder_ == null) {
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.add(builderForValue.build());
        onChanged();
      } else {
        stringControlGGIOBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addStringControlGGIO(
        int index, openfmb.resourcemodule.StringControlGGIO.Builder builderForValue) {
      if (stringControlGGIOBuilder_ == null) {
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.add(index, builderForValue.build());
        onChanged();
      } else {
        stringControlGGIOBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder addAllStringControlGGIO(
        java.lang.Iterable<? extends openfmb.resourcemodule.StringControlGGIO> values) {
      if (stringControlGGIOBuilder_ == null) {
        ensureStringControlGGIOIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, stringControlGGIO_);
        onChanged();
      } else {
        stringControlGGIOBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder clearStringControlGGIO() {
      if (stringControlGGIOBuilder_ == null) {
        stringControlGGIO_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000020);
        onChanged();
      } else {
        stringControlGGIOBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public Builder removeStringControlGGIO(int index) {
      if (stringControlGGIOBuilder_ == null) {
        ensureStringControlGGIOIsMutable();
        stringControlGGIO_.remove(index);
        onChanged();
      } else {
        stringControlGGIOBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.StringControlGGIO.Builder getStringControlGGIOBuilder(
        int index) {
      return getStringControlGGIOFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.StringControlGGIOOrBuilder getStringControlGGIOOrBuilder(
        int index) {
      if (stringControlGGIOBuilder_ == null) {
        return stringControlGGIO_.get(index);  } else {
        return stringControlGGIOBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<? extends openfmb.resourcemodule.StringControlGGIOOrBuilder> 
         getStringControlGGIOOrBuilderList() {
      if (stringControlGGIOBuilder_ != null) {
        return stringControlGGIOBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(stringControlGGIO_);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.StringControlGGIO.Builder addStringControlGGIOBuilder() {
      return getStringControlGGIOFieldBuilder().addBuilder(
          openfmb.resourcemodule.StringControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public openfmb.resourcemodule.StringControlGGIO.Builder addStringControlGGIOBuilder(
        int index) {
      return getStringControlGGIOFieldBuilder().addBuilder(
          index, openfmb.resourcemodule.StringControlGGIO.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .resourcemodule.StringControlGGIO stringControlGGIO = 6 [(.uml.option_multiplicity_min) = 0];</code>
     */
    public java.util.List<openfmb.resourcemodule.StringControlGGIO.Builder> 
         getStringControlGGIOBuilderList() {
      return getStringControlGGIOFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.resourcemodule.StringControlGGIO, openfmb.resourcemodule.StringControlGGIO.Builder, openfmb.resourcemodule.StringControlGGIOOrBuilder> 
        getStringControlGGIOFieldBuilder() {
      if (stringControlGGIOBuilder_ == null) {
        stringControlGGIOBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.resourcemodule.StringControlGGIO, openfmb.resourcemodule.StringControlGGIO.Builder, openfmb.resourcemodule.StringControlGGIOOrBuilder>(
                stringControlGGIO_,
                ((bitField0_ & 0x00000020) != 0),
                getParentForChildren(),
                isClean());
        stringControlGGIO_ = null;
      }
      return stringControlGGIOBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:resourcemodule.ResourceDiscreteControl)
  }

  // @@protoc_insertion_point(class_scope:resourcemodule.ResourceDiscreteControl)
  private static final openfmb.resourcemodule.ResourceDiscreteControl DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.resourcemodule.ResourceDiscreteControl();
  }

  public static openfmb.resourcemodule.ResourceDiscreteControl getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ResourceDiscreteControl>
      PARSER = new com.google.protobuf.AbstractParser<ResourceDiscreteControl>() {
    @java.lang.Override
    public ResourceDiscreteControl parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ResourceDiscreteControl> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ResourceDiscreteControl> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.resourcemodule.ResourceDiscreteControl getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

